/*
    ball-dpF1.hpp - Mlut and DT computations for the 1-Flakes distance in 2D 

    CC BY-SA Edouard.Thiel@univ-amu.fr, rita.zrour@univ-poitiers.fr - 04/08/2023
*/

#ifndef BALL_DPF1_H
#define BALL_DPF1_H

#include "mask-lut.hpp"


class Ball_dpF1 : public MaskLut {

  public :
    void compute_CTg (int L, int *CTg) override;
    void compute_DTg (int L, int *CTg, int *DTg, int R) override;
    int get_greatest_radius (int L) override;

    int min_column_SEDT (int col[], int y, int rows);
    void compute_SEDT_Saito_Toriwaki (cv::Mat &img_int);
    int max_buffer_Saito_rev (int buf[], int pos, int cmax, int a);
    void compute_RSEDT_Saito_Toriwaki (cv::Mat &img_int);
    void compute_level_curves (cv::Mat &img_int);

};  // class Ball_dpF1


#endif // BALL_DPF1_H

